/*
 * text.h
 *
 * Copyright 2022 Jonathan Schöbel <jonathan@Ubermos-2019>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */


#ifndef _TEXT_H
#define _TEXT_H

#include <stdbool.h>

#include "error.h"


#define CHUNK_SIZE 64

struct SH_Text
{
	size_t length;
	size_t size;
	char * text;
};

struct SH_Text * SH_Text_new (struct SH_Error * error);
void SH_Text_free (struct SH_Text * text, struct SH_Error * error);

bool SH_Text_enlarge (struct SH_Text * text, size_t size,
		      struct SH_Error * error);

bool SH_Text_append_string (struct SH_Text * text, char * string,
			    struct SH_Error * error);

bool SH_Text_append_text (struct SH_Text * text, struct SH_Text * text2,
			  struct SH_Error * error);

bool SH_Text_join (struct SH_Text * text, struct SH_Text * text2,
		   struct SH_Error * error);

#endif /* _TEXT_H */
